function f = master(l, risk_type, sample, overlap, iter, income)
%% Parameters
% l = grid
% risk_type = sample used for computing cutoffs
% sample = sample for overlaps
% type = utility 
% overlap = domains considered for overlap
% iter

if overlap(1) == 1 
    % utility type / iteration / grid / risk types for cutoffs
	fgrid(iter, l, risk_type, income);
end

tstart = tic;

strcmp(sample, 'housing')
% load data
if strcmp(sample, 'base') | strcmp(sample, 'housing') | strcmp(sample, 'eq50') | strcmp(sample, 'eq50_150') | strcmp(sample, 'eq150') | strcmp(sample, 'max_401k_1') | strcmp(sample, 'max_401k_0')
    rect = csvread(['../csv/base.csv']);
    data = loadData(rect);

elseif strcmp(sample, 'female_1') | strcmp(sample, 'female_0') | strcmp(sample, 'young_1') | strcmp(sample, 'young_0') | strcmp(sample, 'high_wage_1') | strcmp(sample, 'high_wage_0')
    rect = csvread(['../csv/', sample, '.csv']);
    data = loadData(rect);
end

% define in_sample 
if strcmp(sample,'base') | strcmp(sample,'female_1') | strcmp(sample,'female_0') | strcmp(sample,'young_1') | strcmp(sample,'young_0') | strcmp(sample,'high_wage_1') | strcmp(sample,'high_wage_0')
    in_sample = (data.wage_avg > 0);      % whole sample
end

if strcmp(sample,'housing')
    in_sample = (data.housing.eqamt ~= 99);
end

if strcmp(sample,'eq50')
    in_sample = (data.housing.eqamt == 1);
end

if strcmp(sample,'eq50_150')
    in_sample = (data.housing.eqamt == 2);
end

if strcmp(sample,'eq150')
    in_sample = (data.housing.eqamt == 3);
end

if strcmp(sample,'max_401k_1')
    in_sample = (data.sample.max_match == 1);
end

if strcmp(sample,'max_401k_0')
    in_sample = (data.sample.max_match == 0);
end

% load grid 
grid.name = ['../grids/old_', risk_type, '_', iter,'.mat'];

%% all domains
if overlap(2) == 1 
	overlap_all(data, grid, iter, in_sample, sample);
end

%% insurance domains
if overlap(3) == 1
	overlap_no401k(data, grid, iter, in_sample, sample);
end

%% CARA domains - health, rx, dental
if overlap(4) == 1
	overlap_cara(data, grid, iter, in_sample, sample);
end

%% CRRA domains - stdi, ltdi, 401k
if overlap(5) == 1
	overlap_crra(data, grid, iter, in_sample, sample);
end

tend = toc(tstart);


end
